package com.perforce.hws.core.p4base;

import com.perforce.p4java.client.IClient;
import com.perforce.p4java.exception.AccessException;
import com.perforce.p4java.exception.ConnectionException;
import com.perforce.p4java.exception.RequestException;
import com.perforce.p4java.server.IServer;

import java.util.List;
import java.util.function.Supplier;

/**
 * Methods to help work with p4 client workspaces.
 */
public interface ClientMethods extends P4Methods {

    default void resetClientRoot(Supplier<IServer> s, String clientName, String rootPath) {
        List<ResultMap> resultMaps = exec(s, "client", "-o", clientName);
        ResultMap client = resultMaps.get(0);
        client.put("Root", rootPath);
        execInput(s, client, "client", "-i");
    }

    default void setCurrentClient(Supplier<IServer> s, String clientName) {
        try {
            IClient client = s.get().getClient(clientName);
            s.get().setCurrentClient(client);
        } catch (ConnectionException | RequestException | AccessException e) {
            throw new P4JavaRuntimeException(e);
        }

    }
}
